#	Copyright (c) 2009, 2010 Yves Adler <yves.adler@googlemail.com>
#
#	Permission is hereby granted, free of charge, to any person
#	obtaining a copy of this software and associated documentation
#	files (the "Software"), to deal in the Software without
#	restriction, including without limitation the rights to use,
#	copy, modify, merge, publish, distribute, sublicense, and/or sell
#	copies of the Software, and to permit persons to whom the
#	Software is furnished to do so, subject to the following
#	conditions:
#
#	The above copyright notice and this permission notice shall be
#	included in all copies or substantial portions of the Software.
#
#	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
#	EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
#	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
#	NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
#	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
#	WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
#	OTHER DEALINGS IN THE SOFTWARE.


module EvoSynth
	module Recombinations

		# Returns individual with the shorter genome

		def Recombinations.individual_with_shorter_genome(individual_one, individual_two)
			if individual_one.genome.size > individual_one.genome.size then
				individual_two
			else
				individual_one
			end
		end

	end
end

require 'evosynth/operators/recombinations/uniform_crossover'
require 'evosynth/operators/recombinations/one_point_crossover'
require 'evosynth/operators/recombinations/k_point_crossover'
require 'evosynth/operators/recombinations/identity'
require 'evosynth/operators/recombinations/partially_mapped_crossover'
require 'evosynth/operators/recombinations/ordered_recombination'
require 'evosynth/operators/recombinations/edge_recombination'
require 'evosynth/operators/recombinations/arithmetic_crossover'
